<script setup lang="ts">
import { computed, type ComputedRef, onBeforeMount } from 'vue'
import { useRoute } from 'vue-router'
import { useMovieStore } from '@/stores/movie'
import NotFound from '@/views/NotFound.vue'
import TheLoader from '@/components/TheLoader.vue'
import BookTicket from '@/components/BookTicket.vue'
import { htmlToText } from '@/utils/helpers'
import type { MoviesParams, Movie } from '@/utils/types'

const movie: ComputedRef<Movie | null> = computed(() => movieStore.movie)


const route = useRoute()
const movieId = route.params.id as string
const movieStore = useMovieStore()

onBeforeMount(async () => {
  movieStore.loading = true

  const params: MoviesParams = {movie_id: movieId}
  await movieStore.getMovie(params)

  movieStore.loading = false
})
</script>

<template>
  <TheLoader v-if="movieStore.loading"/>
  <v-container v-else-if="!movieStore.loading && movie">
    <v-row>
      <v-col cols="12" xl="2" lg="4" sm="5">
        <v-img :src="movie.image"
               :alt="movie.name"
               color="grey-lighten-2"
               cover
        />
        <BookTicket :id="movieId"/>
      </v-col>

      <v-col cols="12" xl="10" lg="8" sm="7">
        <h1 class="">{{ movie.name }}</h1>
        <article class="article-details mt-5" v-html="movie.additional"/>
        <article class="mt-5" v-html="htmlToText(movie.description as string)"/>
      </v-col>
    </v-row>
  </v-container>
  <NotFound v-else/>
</template>
